<?php

class NewsAPIClient {

    /**
     * Constructor
     */
    public function __Construct() {
        $this->apiKey = NEWS_API_KEY;
        echo $this->apiKey;
    }

    /**
     * Get Top Headlines from NewsAPI
     * @param type $options
     * @return type
     */
    public function getTopHeadLines($options = array()) {
        $results = $this->makeRequest($this->createRequest('top-headlines', $options));
        return !empty($results->articles) ? $results->articles : array();
    }
    /**
     * Get Evertyhing from NewsAPI
     * @param type $options
     * @return type
     */
    public function getEverything($options) {
        $results = $this->makeRequest($this->createRequest('everything', $options));
        return !empty($results->articles) ? $results->articles : array();
    }
    /**
     * Get Sources from NewsAPI
     * @param type $options
     * @return type
     */
    public function getSources($options) {
        $results = $this->makeRequest($this->createRequest('sources', $options));
        return !empty($results->sources) ? $results->sources : array();
    }

    /**Does the job for you*/    
    public function makeRequest($request) {
        $ch = curl_init($request);
        curl_setopt_array($ch, $this->setCURLParams());
        $results = curl_exec($ch);
        curl_close($ch);
        $response = json_decode($results);
        if ($response->status === 'ok') {
            return $response;
        } elseif ($response->status === 'error') {
            echo $response->code . '<br />';
            echo $response->message . '<br />';
            return array();
        } else {
            echo 'Error in Making Request. No message returned.';
            return array();
        }
    }
    /**
     * Create the Request for NewsAPI
     * @param string $APIMethod
     * @param array $params
     * @return curl request object
     */
    public function createRequest($APIMethod, $params = array()) {
        $request = BASE_URL . NEWS_API_VERSION . "/{$APIMethod}?apiKey={$this->apiKey}";
        foreach ($params as $key => $value) {
            $request.= "&{$key}={$value}";
        }
        return $request;
    }
    /**
     * Set the Curl Parameters
     * @return string
     */
    public function setCURLParams() {
        $curlParams = array();
        $curlParams[CURLOPT_FOLLOWLOCATION] = 1; //true,
        $curlParams[CURLOPT_CONNECTTIMEOUT] = 10;
        $curlParams[CURLOPT_MAXREDIRS] = 3;
        $curlParams[CURLOPT_HEADER] = false;
        $curlParams[CURLOPT_RETURNTRANSFER] = true;
        $curlParams[CURLOPT_HTTPHEADER] = array(
            'Content-Type: application/json',
            "Authorization: {$this->apiKey}",
        );
        return $curlParams;
    }

}
